package cordova.plugins;

import org.apache.cordova.CordovaWebView;
import org.apache.cordova.CallbackContext;
import org.apache.cordova.CordovaPlugin;
import org.apache.cordova.CordovaInterface;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.stroeven.greeter.*;
import com.viatom.azur.bluetooth.*;
import com.viatom.azur.measurement.*;
import com.viatom.azur.utils.*;

import android.content.ServiceConnection;
import android.content.Intent;
import android.app.Service;
import android.content.ComponentName;
import android.os.IBinder;
import android.os.Binder;
import android.content.Context;
import android.content.pm.PackageManager;
import android.content.pm.ResolveInfo;
import java.util.List;


public class checkMeInterface extends CordovaPlugin implements BTConnectListener{

    private CordovaInterface cordova;
    private CordovaWebView webView;
    private BTUtils.BTBinder mBinder;

    
     private ServiceConnection conn = new ServiceConnection(){
            @Override
            public void onServiceConnected(ComponentName name, IBinder service){
                
                mBinder = (BTUtils.BTBinder) service;
                webView.loadUrl("javascript:console.log('System has been bound - BTUTILS BIND');");
                
            }

            @Override
            public void onServiceDisconnected (ComponentName name){
                System.out.println("Service has been disconnected.");
            }
    };
    
    
	@Override
    public void initialize(CordovaInterface cordova, CordovaWebView webView) {
    	super.initialize(cordova, webView);
    	this.cordova = cordova;
    	this.webView = webView;
    }

    @Override
    public boolean execute(String action, JSONArray args, CallbackContext callbackContext) throws JSONException {
        if (action.equals("sayHello")) {
            callbackContext.success(sayHello());
            return true;
        }
        if(action.equals("initBTUtils")){
            callbackContext.success(bindBTUtils());
        }
        return false;
    }

    public String sayHello(){
        return Greeter.greet();
    }

    public String bindBTUtils(){
        testBindService();
        return "BTUtils bound - ready to proceed";
    }

    public void testBindService(){
    	Intent intent = new Intent("com.viatom.azur.BTUtils");
    	intent.setPackage("com.viatom.azure");
        cordova.getActivity().getApplicationContext().bindService(intent, conn, Service.BIND_AUTO_CREATE);
    }
    
    public boolean testConnectCheckme(String macAddress){
    	if(mBinder != null){
    		//mBinder.isAnyThreadRunning();
    		//mBinder.interfaceConnect(macAddress, this);
    		return true;
    	}else{
    		return false;
    	}
    }
    
    @Override
    public void onConnectSuccess(){
    		
    }
    
    @Override
    public void onConnectFailed(byte errCode){
    	
    }

    
}